function [Msez,Nsez,LAST_CLS,LAST_STEEL] = MN_NEW (eps_G,curv,GEOM,CLS,STEEL,section_type)


%INPUT -
%OUTPUT -


nfib=GEOM.nfib;
dfib_G=GEOM.dfib_G;
area_fib=GEOM.area_fib;
Af=GEOM.Af;
d_Af_G=GEOM.d_Af_G;
legame_acciaio=STEEL.legame_acciaio;
legame_cls=CLS.legame_cls;

eps_cls=eps_G+curv*dfib_G;
for i=1:nfib
    switch legame_cls
        case 'sigma_eps_concrete_mander'
            [f_cls(i),LAST_CLS(i,:)] = sigma_eps_concrete_mander (i,eps_cls(i),CLS,GEOM,section_type);
        case 'sigma_eps_concrete_par_rett'
            [f_cls(i),LAST_CLS(i,:)] = sigma_eps_concrete_par_rett (eps_cls(i),CLS);
    end
end
Nsez=sum(f_cls.*area_fib);
Msez=sum(f_cls.*area_fib.*dfib_G);

eps_steel=eps_G+curv*d_Af_G;
for i=1:length(Af)
    switch legame_acciaio
        case 'sigma_eps_steel_hardening'
            [f_steel(i),LAST_STEEL(i,:)] = sigma_eps_steel_hardening (eps_steel(i),STEEL);
        case 'sigma_eps_steel_perfectly_plastic'
            [f_steel(i),LAST_STEEL(i,:)] = sigma_eps_steel_perfectly_plastic (eps_steel(i),STEEL);
    end
end
Nsez=Nsez+sum(f_steel.*Af);
Msez=Msez+sum(f_steel.*Af.*d_Af_G);


